/* 
 *     XaoS, a fast portable realtime fractal zoomer 
 *                  Copyright (C) 1996,1997 by
 *
 *      Jan Hubicka          (hubicka@paru.cas.cz)
 *      Thomas Marsh         (tmarsh@austin.ibm.com)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
static char *helptext[] =
{
  "  PRESS H AGAIN FOR ANIMATED TUTORIALS ",
  "                                       ",
  "buttons:                               ",
  "left-zoom in           right-zoom out  ",
  "middle(or left+right)-move             ",
  "                                       ",
  "keys:                                  ",
  "1-9 fractal type      A autopilot      ",
  "H help                C out coloring   ",
  "F In coloring         I plane switching",
  "S Save/load           P Random palette ",
  "Q Quit                M Mand/Julia     ",
  "D Default palette     J Fast julia     ",
  "= Resize              ? Status         ",
  "R Recalculate     Space redraw screen  ",
  "V Various stuff menu  Z interrupt      ",
  "L Status line         Y Color cycling  ",
  "E Enable/dis. filter  O Image rotation ",
  "B Perturbation                         ",
  "                                       ",
  "Up/Down-change zooming speed           ",
  "Left/Right-number of iterations        ",
  "                                       ",
  "animation replay keys:                 ",
  "Q      stop animation replay           ",
  "Space  skip frame (should take a while)",
  "Left/Right-adjust subtitles speed      ",
  "Z      Interrupt current calculation   ",
  "S      Save current image              ",
  "L      Enable/disable status line      ",
  "=      Resize                          ",
  "                                       ",
  "CONTENTS                               ",
  "=======                                ",
  " o Keys summary                        ",
  " o contents                            ",
  " o fractal type                        ",
  " o planes                              ",
  " o in coloring                         ",
  " o out coloring                        ",
  " o Mand/Julia                          ",
  " o Dynamical resolution                ",
  " o Color cycling                       ",
  " o Image rotation                      ",
  " o Filters                             ",
  " o The save/load menu                  ",
  " o Why ugly interface                  ",
  " o homepage                            ",
  " o The large XaoS gallery              ",
  " o mailing lists                       ",
  " o Contact to author                   ",
  " o driver depended documentation       ",
  "                                       ",
  "                                       ",
  "                                       ",
  "FRACTAL TYPE                           ",
  "============                           ",
  "Fractal type may be changed by pressing",
  "number key when no menu is displayed.  ",
  "key  fractal                           ",
  " 1   Infamous fractal called Mandelbrot",
  "     set                               ",
  " 2-5 Mandelbrot set with higher power  ",
  "     Mandelbrot's formula is: z=z^2 + c",
  "     This fractals are same except ^2  ",
  "     is changed to ^3 and more         ",
  " 6   Octal. This is some infamous      ",
  "     Fractal that Thomas discovered in ",
  "     Fractint. Nice in other planes    ",
  " 7   Newton. This fractal uses old     ",
  "     famous formula for finding roots  ",
  "     of polygon discovered by Isaac.   ",
  " 8   Barnsley.                         ",
  " 9   Phoenix. Very nice fractal.       ",
  " 0   Magnet. Famos fractal. Bit slower ",
  "     than previous ones                ",
  "                                       ",
  "                                       ",
  "                                       ",
  "PLANES                                 ",
  "======                                 ",
  "All fractals displayed by XaoS are     ",
  "function with complex parameter.       ",
  "It can be displayed in normal complex  ",
  "plane where x is real part of number   ",
  "and y is imaginary. But may be also    ",
  "displayed in some more funny modes:    ",
  " 1   mu                                ",
  "      normal mode..                    ",
  " 2   1/mu                              ",
  "      Inversion-infinity is in 0 and   ",
  "      0 is in infinity.                ",
  " 3   1/(mu+0.25)                       ",
  "      Similar to inversion but moves   ",
  "      center outside of Mandelbrot     ",
  "      so it looks parabolic            ",
  " 4   lambda plane                      ",
  " 5   1/lambda                          ",
  " 6   1/lambda-1                        ",
  " 7   1/(mu-1.40115                     ",
  "      Very interesting mode for        ",
  "      Mandelbrot set. Makes small      ",
  "      thinks big. So you can           ",
  "      browse its details.              ",
  "                                       ",
  "                                       ",
  "                                       ",
  "OUT COLORING MODES                     ",
  "==================                     ",
  "Z value from last iteration is taken   ",
  "and used by some funny formula to      ",
  "modify color by some way to make it    ",
  "more interesting                       ",
  "                                       ",
  "                                       ",
  "                                       ",
  "IN COLORING MODES                      ",
  "=================                      ",
  "Similar as out-coloring modes but done ",
  "for points inside set.                 ",
  "                                       ",
  "                                       ",
  "                                       ",
  "MANDELBROT/JULIA                       ",
  "================                       ",
  "Most of fractals displayed by XaoS has ",
  "two forms-Mandelbrot and Julia.        ",
  "Every point in Mandelbrot version have ",
  "its own Julia set.                     ",
  "You may switch between them by key 'M' ",
  "Be careful in Mandelbrot to Julia      ",
  "switching, because you need to specify ",
  "point for Julia base. Most interesting ",
  "Julias has points at boundaries of set.",
  "So place pointer to some interesting   ",
  "place and press 'M'. Switching back    ",
  "switches always into same set.         ",
  "If set is in Mandelbrot or Julia mode  ",
  "is displayed in status line.           ",
  "                                       ",
  "Looking for good point as base for     ",
  "julias is not easy. Needs some         ",
  "experience so XaoS supports fast julia ",
  "browsing mode. Press 'J' and move      ",
  "mouse arround with pressed left button.",
  "Corresponding julias will be quickly   ",
  "displayed in left top corner. This mode",
  "is not available for phoenix fractal   ",
  "because its formula uses two previous  ",
  "iterations that makes imposible such   ",
  "optimizations. Also optimizations used ",
  "makes mistakes that should make julia  ",
  "look bit different from real one. But  ",
  "for orientation it is OK.              ",
  "                                       ",
  "                                       ",
  "                                       ",
  "DYNAMICAL RESOLUTION                   ",
  "====================                   ",
  "Fractal zooming is very expensive      ",
  "calculation. XaoS uses lots of special ",
  "optimizations and tricks to archieve   ",
  "its speed. But sometimes it is still   ",
  "slow. In this situations XaoS          ",
  "automatically lowers details on        ",
  "calculated image. You may control this ",
  "feature from 'v'-'3' menu.             ",
  "By pressing '1' you may disable this   ",
  "feature. In case you dislike it.       ",
  "By pressing '2' xaos lowers resolution ",
  "just inside zooming animation. This is ",
  "the default behaviour.                 ",
  "By pressing '3' you may enable         ",
  "resolution lowering mode for new images",
  "too. This enables quite nice effect    ",
  "where low detail image is displayed    ",
  "first and then new and new rows/columns",
  "are calculated. At the other hand this ",
  "slows down main calculation.           ",
  "                                       ",
  "                                       ",
  "                                       ",
  "COLOR CYCLING                          ",
  "=============                          ",
  "This old but nice trick is available   ",
  "at key 'Y'. Problem is that rotation of",
  "palettes is very easy on old vga but   ",
  "should be very complicated on windowed ",
  "enviroment/truecolor displays where    ",
  "changing of palette is impossible. So  ",
  "not all driver supports this. (For     ",
  "example curses driver). Some of them   ",
  "supports this just partialy-X11 driver ",
  "that does not support it in 8bpp       ",
  "pseudocolor modes w/o private colormap.",
  "For more details see driver's          ",
  "documentation at the end of this help. ",
  "                                       ",
  "                                       ",
  "                                       ",
  "IMAGE ROTATION                         ",
  "==============                         ",
  "XaoS can display fractal rotated for   ",
  "given angle. Problem is that changing  ",
  "of this angle requires recalculation of",
  "whole screen. This makes impossible    ",
  "nice smooth rotation of fractal. But   ",
  "XaoS provides fast rotating mode, where",
  "fractal is calculated with angle 0 and ",
  "then rotated as image. This slowes down",
  "and makes image less exact but smooth  ",
  "rotation is possible. You may switch   ",
  "between this modes by key 'O'. First   ",
  "press involves recalculation(switch to ",
  "fast rotation mode) and enables        ",
  "continous rotation of image. You should",
  "do everything as in normal. Pressing   ",
  "'O' again stops rotation but keeps fast",
  "rotation mode. Now you can adjust angle",
  "using first button by drag&drop.       ",
  "Pressing 'O' again recalculates screen ",
  "and disables fast rotation mode but    ",
  "keeps angle you choose.                ",
  "Note that speed of continous rotation  ",
  "can be adjusted using arrow keys.      ",
  "                                       ",
  "                                       ",
  "                                       ",
  "FILTERS                                ",
  "=======                                ",
  "Filter is an effect applied to image   ",
  "after it is calculated. XaoS has       ",
  "implemented following filters:         ",
  "  o Random dod stereogram              ",
  "  o Motion blur                        ",
  "  o Two edge detection filters         ",
  "  o Interlace                          ",
  "For full description about above       ",
  "see tutorial XaoS's features overview /",
  "filters. They should be enabled /      ",
  "disabled by pressing 'E'. Note that    ",
  "multiple filters should be enabled at a",
  "time but not all combinations are      ",
  "acceptable. So if filter refuses to    ",
  "eanble try to disable others.          ",
  "                                       ",
  "                                       ",
  "                                       ",
  "THE SAVE/LOSD MENU                     ",
  "==================                     ",
  "Save menu should be activated by 'S'   ",
  "It contains various saving commands.   ",
  "                                       ",
  "Save image to PNG file                 ",
  " This saves image into PNG - an quite  ",
  " popular graphics image format. You    ",
  " should then use it in other software  ",
  " or put to web page (since most of     ",
  " browsers already supports PNG - it is ",
  " format designed for this purposes.)   ",
  " Filename is choosed automatically -   ",
  " fract<num>.png                        ",
  "Save possition                         ",
  " This saves possition into XaoS's      ",
  " native file format so it should be    ",
  " readed again using xaos -load <name>  ",
  " Filename is again choosed automatical.",
  " fract<num>.xpf (XaoS possition file)  ",
  " This format also is much shorter than ",
  " image files.                          ",
  " Please send me all nice images you    ",
  " created into XaoS gallery.            ",
  "Record animation                       ",
  " This enables animation recording into ",
  " anim<num>.xaf (XaoS animation file)   ",
  " All you do then is recorded into this ",
  " file and you should replay it later   ",
  " xaos -play <filename>. Note that      ",
  " format is human readable so it allow  ",
  " later manual modification of file or  ",
  " writting animations manually. See     ",
  " documentation for more details.       ",
  " Also save menu is changed when        ",
  " recording is active and allows you to ",
  " do thinks like clear screen, print    ",
  " text and stop animation recording.    ",
  "                                       ",
  " Please send me all nice animations you",
  " created into XaoS gallery.            ",
  "Load random example                    ",
  " Loads random file from examples       ",
  " directory                             ",
  "Use current settings as default        ",
  " Saves current setting into            ",
  " configuration file automatically      ",
  " loaded at startup. Name of this file  ",
  " depends at platform(~/.XaoSrc at UNIX,",
  " xaos.cfg at dos etc...)               ",
  "                                       ",
  "                                       ",
  "                                       ",
  "WHY UGLY INTERFACE?                    ",
  "=====================                  ",
  "I know that only good, intuitive       ",
  "user interface can make program        ",
  "popular. So I decided to make          ",
  "__REALLY__ _REALLY_ good interface     ",
  "for XaoS. I started work at            ",
  "real-time ray-traced marble rotating   ",
  "buttons with metal shaded gothical     ",
  "gold letters and true-color 3d         ",
  "icons with fractal landscape           ",
  "reflecting inside. All of course       ",
  "with 3d 32 channel surround sound      ",
  "and for 3d monitor with special 3d     ",
  "mouse called batman.                   ",
  "But than something inside me said      ",
  "NO! You like vi, emacs, ed and use     ",
  "X only for starting xterm so           ",
  "why to make xaos different?            ",
  "All this programs has very             ",
  "powerful and simple user               ",
  "interface. So I started work on        ",
  "something minimal but powerful.        ",
  "And ugly interface is result!          ",
  "Of course main purpose is that I       ",
  "am lazy.                               ",
  "                                       ",
  "                                       ",
  "STATUS LINE                            ",
  "===========                            ",
  "This line contains few funny           ",
  "informations:                          ",
  " - how deep you are zoomed             ",
  " - how many frames per second          ",
  "   generated                           ",
  " - if autopilot is enabled             ",
  " - outcoloringmode,incoloringmode      ",
  "   plane and number of iterations      ",
  "                                       ",
  "                                       ",
  "                                       ",
  "HOMEPAGE                               ",
  "========                               ",
  "Additional informations, gallery, XaoS ",
  "sources, tutorial and much more can be ",
  "found at xaos homepage:                ",
  "http://www.paru.cas.cz/~hubicka/XaoS   ",
  "                                       ",
  "                                       ",
  "                                       ",
  "                                       ",
  "THE LARGE XAOS GALLERY                 ",
  "======================                 ",
  "Since XaoS support saving, I plan to   ",
  "create web site dedicated to XaoS      ",
  "possition filter and animations.       ",
  "                                       ",
  "Please send me all nice fractals and   ",
  "animations you created. Gallery will be",
  "at XaoS homepage.                      ",
  "                                       ",
  "                                       ",
  "                                       ",
  "MAILING LISTS                          ",
  "=============                          ",
  "You may also subscribe following lists:",
  " xaos    -   general discusion about   ",
  "             XaoS                      ",
  " xaos-announce - keeps you informed    ",
  "             about new versions        ",
  " xaos-devel -you want to become XaoS   ",
  "             developer? subscribe here ",
  "to subscribe send following message:   ",
  "                                       ",
  " subscribe <list name>                 ",
  "                                       ",
  "to majordomo@horac.ta.jcu.cz           ",
  "                                       ",
  "                                       ",
  "                                       ",
  "CONTACT TO AUTHORS:                    ",
  "==================                     ",
  "Jan Hubicka:                           ",
  "hubicka@paru.cas.cz in case of problems",
  "hubicka@tabor.ta.jcu.cz                ",
  "hubicka@atrey.karlin.mff.cuni.cz       ",
  "                                       ",
  "smail:                                 ",
  "                                       ",
  "Jan Hubicka                            ",
  "Dukelskych bojovniku 1944              ",
  "Tabor 390 03                           ",
  "Czech Republic                         ",
  "                                       ",
  "Thomas Marsh:                          ",
  "tmarsh@austin.ibm.com                  ",
  "                                       ",
  "                                       ",
  "                                       ",
  "All bug reports, flames, contributions,",
  "      thanks,etc.. welcomed!           ",
  "                                       ",
  "                                       ",
  "                                       ",

};
#define UGLYTEXTSIZE (sizeof(helptext)/sizeof(char *))
